package org.antlr.grammar.v3;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.grammar.v3.ANTLRParser;
import org.antlr.runtime.IntStream;
import org.antlr.runtime.MissingTokenException;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.Token;
import org.antlr.runtime.TokenStream;
import org.antlr.runtime.UnwantedTokenException;
import org.antlr.tool.GrammarAST;

class GrammarASTErrorNode extends GrammarAST {
  public IntStream input;
  
  public Token start;
  
  public Token stop;
  
  public RecognitionException trappedException;
  
  public GrammarASTErrorNode(TokenStream input, Token start, Token stop, RecognitionException e) {
    super(stop);
    if (stop == null || (stop.getTokenIndex() < start.getTokenIndex() && stop.getType() != -1))
      stop = start; 
    this.input = input;
    this.start = start;
    this.stop = stop;
    this.trappedException = e;
  }
  
  public boolean isNil() {
    return false;
  }
  
  public String getText() {
    String badText = null;
    if (this.start != null) {
      int i = this.start.getTokenIndex();
      int j = this.stop.getTokenIndex();
      if (this.stop.getType() == -1)
        j = this.input.size(); 
      badText = ((TokenStream)this.input).toString(i, j);
    } else {
      badText = "<unknown>";
    } 
    return badText;
  }
  
  public void setText(String value) {}
  
  public int getType() {
    return 0;
  }
  
  public void setType(int value) {}
  
  public String toString() {
    if (this.trappedException instanceof MissingTokenException)
      return "<missing type: " + ((MissingTokenException)this.trappedException).getMissingType() + ">"; 
    if (this.trappedException instanceof UnwantedTokenException)
      return "<extraneous: " + ((UnwantedTokenException)this.trappedException).getUnexpectedToken() + ", resync=" + getText() + ">"; 
    if (this.trappedException instanceof org.antlr.runtime.MismatchedTokenException)
      return "<mismatched token: " + this.trappedException.token + ", resync=" + getText() + ">"; 
    if (this.trappedException instanceof org.antlr.runtime.NoViableAltException)
      return "<unexpected: " + this.trappedException.token + ", resync=" + getText() + ">"; 
    return "<error: " + getText() + ">";
  }
}
